// Generated by CoffeeScript 1.8.0
(function() {
  var BunyanDebugStream, EXPRESS_BUNYAN_LOGGER_FIELDS, FIELDS_TO_IGNORE, INDENT, LEVELS, Writable, applyColors, bunyan, colors, dateToString, exceptionFormatter, exports, isString, path, serializer, serializerName, serializers, srcToString, _ref, _ref1,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  path = require('path');

  Writable = require('stream').Writable;

  bunyan = require('bunyan');

  colors = require('colors/safe');

  exceptionFormatter = require('exception-formatter');

  _ref = require('./utils'), srcToString = _ref.srcToString, applyColors = _ref.applyColors, dateToString = _ref.dateToString, isString = _ref.isString;

  LEVELS = (function() {
    var answer, o;
    answer = {};
    o = function(level, prefix, colors) {
      return answer[level] = {
        level: level,
        prefix: prefix,
        colors: colors
      };
    };
    o(bunyan.TRACE, 'TRACE:', ['grey']);
    o(bunyan.DEBUG, 'DEBUG:', ['cyan']);
    o(bunyan.INFO, 'INFO: ', ['green']);
    o(bunyan.WARN, 'WARN: ', ['yellow']);
    o(bunyan.ERROR, 'ERROR:', ['red']);
    o(bunyan.FATAL, 'FATAL:', ['magenta']);
    return answer;
  })();

  FIELDS_TO_IGNORE = ['src', 'msg', 'name', 'hostname', 'pid', 'level', 'time', 'v', 'err'];

  EXPRESS_BUNYAN_LOGGER_FIELDS = ['remote-address', 'ip', 'method', 'url', 'referer', 'user-agent', 'body', 'short-body', 'http-version', 'response-hrtime', 'status-code', 'req-headers', 'res-headers', 'incoming', 'req_id'];

  INDENT = "  ";

  BunyanDebugStream = (function(_super) {
    __extends(BunyanDebugStream, _super);

    function BunyanDebugStream(options) {
      var c, key, level, levelName, levelValue, self, value, _ref1, _ref10, _ref11, _ref12, _ref13, _ref2, _ref3, _ref4, _ref5, _ref6, _ref7, _ref8, _ref9;
      this.options = options != null ? options : {};
      BunyanDebugStream.__super__.constructor.call(this, {
        objectMode: true
      });
      this._colors = {};
      if (('colors' in this.options) && !this.options.colors) {
        this._useColor = false;
        for (levelValue in LEVELS) {
          level = LEVELS[levelValue];
          this._colors[levelValue] = [];
        }
      } else {
        this._useColor = true;
        for (levelValue in LEVELS) {
          level = LEVELS[levelValue];
          this._colors[levelValue] = level.colors;
        }
        _ref2 = (_ref1 = this.options.colors) != null ? _ref1 : {};
        for (level in _ref2) {
          c = _ref2[level];
          if (isString(c)) {
            c = [c];
          }
          if (this._colors[level] != null) {
            this._colors[level] = c;
          } else {
            levelName = level;
            level = bunyan[levelName != null ? levelName.toUpperCase() : void 0];
            if (this._colors[level] != null) {
              this._colors[level] = c;
            } else {

            }
          }
        }
      }
      this._processName = (_ref3 = (_ref4 = (_ref5 = this.options.processName) != null ? _ref5 : (process.argv.length > 1 ? path.basename(process.argv[1], path.extname(process.argv[1])) : void 0)) != null ? _ref4 : (process.argv.length > 0 ? path.basename(process.argv[0], path.extname(process.argv[0])) : void 0)) != null ? _ref3 : '';
      self = this;
      this._stringifiers = {
        req: exports.stdStringifiers.req,
        err: exports.stdStringifiers.err
      };
      if (this.options.stringifiers != null) {
        _ref6 = this.options.stringifiers;
        for (key in _ref6) {
          value = _ref6[key];
          this._stringifiers[key] = value;
        }
      }
      this._prefixers = (_ref7 = this.options.prefixers) != null ? _ref7 : {};
      this._out = (_ref8 = this.options.out) != null ? _ref8 : process.stdout;
      this._basepath = (_ref9 = this.options.basepath) != null ? _ref9 : process.cwd();
      this._showDate = (_ref10 = this.options.showDate) != null ? _ref10 : true;
      this._showLoggerName = (_ref11 = this.options.showLoggerName) != null ? _ref11 : true;
      this._showPid = (_ref12 = this.options.showPid) != null ? _ref12 : true;
      this._showLevel = (_ref13 = this.options.showLevel) != null ? _ref13 : true;
    }

    BunyanDebugStream.prototype._runStringifier = function(entry, key, stringifier, consumed, message) {
      var err, newMessage, result, value, _i, _len, _ref1, _ref2;
      consumed[key] = true;
      value = null;
      newMessage = message;
      try {
        if (stringifier == null) {

        } else {
          result = stringifier(entry[key], {
            entry: entry,
            useColor: this._useColor,
            debugStream: this
          });
          if (result == null) {

          } else if (isString(result)) {
            value = result;
          } else {
            _ref2 = (_ref1 = result.consumed) != null ? _ref1 : [];
            for (_i = 0, _len = _ref2.length; _i < _len; _i++) {
              key = _ref2[_i];
              consumed[key] = true;
            }
            if (result.value != null) {
              if (result.replaceMessage) {
                newMessage = result.value;
                value = null;
              } else {
                value = result.value;
              }
            }
          }
        }
      } catch (_error) {
        err = _error;
        newMessage = message;
        value = "Error running stringifier:\n" + err.stack;
      }
      if (value != null) {
        value = value.replace(/\n/g, "\n" + INDENT);
      }
      return {
        message: newMessage,
        value: value
      };
    };

    BunyanDebugStream.prototype._entryToString = function(entry) {
      var colorsToApply, cols, consumed, date, field, key, levelPrefix, line, message, prefixer, prefixes, processStr, src, start, stringifier, value, valueString, values, _i, _len, _ref1, _ref2, _ref3, _ref4, _ref5, _ref6, _ref7, _ref8;
      if (typeof entry === 'string') {
        entry = JSON.parse(entry);
      }
      colorsToApply = this._colors[(_ref1 = entry.level) != null ? _ref1 : bunyan.INFO];
      src = srcToString(entry.src, this._basepath, this.options.basepathReplacement);
      if (src) {
        src += ': ';
      }
      message = entry.msg;
      consumed = {};
      for (_i = 0, _len = FIELDS_TO_IGNORE.length; _i < _len; _i++) {
        field = FIELDS_TO_IGNORE[_i];
        consumed[field] = true;
      }
      values = [];
      _ref2 = this._stringifiers;
      for (key in _ref2) {
        stringifier = _ref2[key];
        if (entry[key] != null) {
          _ref3 = message = this._runStringifier(entry, key, stringifier, consumed, message), message = _ref3.message, value = _ref3.value;
          if (value != null) {
            values.push("" + INDENT + key + ": " + value);
          }
        } else {
          consumed[key] = true;
        }
      }
      prefixes = [];
      _ref4 = this._prefixers;
      for (key in _ref4) {
        prefixer = _ref4[key];
        if (entry[key] != null) {
          _ref5 = this._runStringifier(entry, key, prefixer, consumed, message), message = _ref5.message, value = _ref5.value;
          if (value != null) {
            prefixes.push(value);
          }
        } else {
          consumed[key] = true;
        }
      }
      for (key in entry) {
        value = entry[key];
        if (consumed[key]) {
          continue;
        }
        valueString = JSON.stringify(value);
        if (valueString != null) {
          cols = process.stdout.columns;
          start = "" + INDENT + key + ": ";
          if (cols && (valueString.length + start.length) >= cols) {
            valueString = valueString.slice(0, cols - 3 - start.length) + "...";
          }
          values.push("" + start + valueString);
        }
      }
      prefixes = prefixes.length > 0 ? "[" + (prefixes.join(',')) + "] " : '';
      date = this._showDate ? "" + (dateToString((_ref6 = entry.time) != null ? _ref6 : new Date())) + " " : '';
      processStr = "";
      if (this.options.showProcess) {
        processStr += this._processName;
      }
      if (this._showLoggerName) {
        processStr += entry.name;
      }
      if (this._showPid) {
        processStr += "[" + entry.pid + "]";
      }
      if (processStr.length > 0) {
        processStr += " ";
      }
      levelPrefix = this._showLevel ? ((_ref7 = (_ref8 = LEVELS[entry.level]) != null ? _ref8.prefix : void 0) != null ? _ref7 : '      ') + ' ' : '';
      line = "" + date + processStr + levelPrefix + src + prefixes + (applyColors(message, colorsToApply));
      if (typeof request !== "undefined" && request !== null) {
        line += "\n" + INDENT + request;
      }
      if (values.length > 0) {
        line += "\n" + applyColors(values.join('\n'), colorsToApply);
      }
      return line;
    };

    BunyanDebugStream.prototype._write = function(entry, encoding, done) {
      this._out.write(this._entryToString(entry) + "\n");
      return done();
    };

    return BunyanDebugStream;

  })(Writable);

  module.exports = exports = function(options) {
    return new BunyanDebugStream(options);
  };

  serializers = module.exports.serializers = {};

  _ref1 = bunyan.stdSerializers;
  for (serializerName in _ref1) {
    serializer = _ref1[serializerName];
    serializers[serializerName] = serializer;
  }

  serializers.req = function(req) {
    var answer;
    answer = bunyan.stdSerializers.req(req);
    if (answer != null) {
      if (req.user != null) {
        answer.user = req != null ? req.user : void 0;
      }
    }
    return answer;
  };

  serializers.res = function(res) {
    var answer;
    answer = bunyan.stdSerializers.res(res);
    if (answer != null) {
      answer.headers = res._headers;
      if (res.responseTime != null) {
        answer.responseTime = res.responseTime;
      }
    }
    return answer;
  };

  exports.stdStringifiers = {
    req: function(req, _arg) {
      var consumed, contentLength, entry, fields, host, replaceMessage, request, res, responseTime, status, statusCode, statusColor, url, useColor, user, _ref10, _ref11, _ref12, _ref13, _ref14, _ref2, _ref3, _ref4, _ref5, _ref6, _ref7, _ref8, _ref9;
      entry = _arg.entry, useColor = _arg.useColor;
      consumed = ['req', 'res'];
      res = entry.res;
      if ((entry['status-code'] != null) && (entry['method'] != null) && (entry['url'] != null) && (entry['res-headers'] != null)) {
        consumed = consumed.concat(EXPRESS_BUNYAN_LOGGER_FIELDS);
      }
      statusCode = (_ref2 = res != null ? res.statusCode : void 0) != null ? _ref2 : entry['status-code'];
      if (statusCode != null) {
        status = "" + statusCode;
        if (useColor) {
          statusColor = statusCode < 200 ? colors.grey : statusCode < 400 ? colors.green : colors.red;
          status = colors.bold(statusColor(status));
        }
      } else {
        status = "";
      }
      responseTime = (res != null ? res.responseTime : void 0) != null ? res.responseTime : entry.duration != null ? (consumed.push('duration'), entry.duration) : entry["response-time"] != null ? (consumed.push("response-time"), entry["response-time"]) : null;
      if (responseTime != null) {
        responseTime = "" + responseTime + "ms";
      } else {
        responseTime = "";
      }
      user = req.user != null ? "" + ((_ref3 = (_ref4 = (_ref5 = req.user) != null ? _ref5.username : void 0) != null ? _ref4 : (_ref6 = req.user) != null ? _ref6.name : void 0) != null ? _ref3 : req.user) + "@" : entry.user != null ? (consumed.push("user"), "" + ((_ref7 = (_ref8 = (_ref9 = entry.user) != null ? _ref9.username : void 0) != null ? _ref8 : (_ref10 = entry.user) != null ? _ref10.name : void 0) != null ? _ref7 : entry.user) + "@") : "";
      contentLength = (_ref11 = res != null ? (_ref12 = res.headers) != null ? _ref12['content-length'] : void 0 : void 0) != null ? _ref11 : (_ref13 = entry['res-headers']) != null ? _ref13['content-length'] : void 0;
      contentLength = contentLength != null ? "- " + contentLength + " bytes" : "";
      host = ((_ref14 = req.headers) != null ? _ref14.host : void 0) || null;
      url = host != null ? "" + host + req.url : "" + req.url;
      fields = [req.method, user + url, status, responseTime, contentLength];
      fields = fields.filter(function(f) {
        return !!f;
      });
      request = fields.join(' ');
      replaceMessage = !entry.msg || entry.msg === 'request finish';
      return {
        consumed: consumed,
        value: request,
        replaceMessage: replaceMessage
      };
    },
    err: function(err, _arg) {
      var debugStream, useColor, _ref2, _ref3, _ref4;
      useColor = _arg.useColor, debugStream = _arg.debugStream;
      return exceptionFormatter(err, {
        format: useColor ? 'ansi' : 'ascii',
        colors: false,
        maxLines: (_ref2 = (_ref3 = debugStream.options) != null ? _ref3.maxExceptionLines : void 0) != null ? _ref2 : null,
        basepath: debugStream._basepath,
        basepathReplacement: (_ref4 = debugStream.options) != null ? _ref4.basepathReplacement : void 0
      });
    }
  };

}).call(this);
